/**********************************************
* GPS LoggervO
*   PIC24FJ64GA002 family 
*   SW1FOJn/~
*   SW2FOԊu̐ݒ
*@@SDJ[hւ̃OtH[}bg
***********************************************/
#include "p24FJ64GA002.h"
#include "FSIO.h"
#include <stdio.h>
#include <string.h>
#include "LCD_Lib3.h"

// Setup configuration bits
_CONFIG1( JTAGEN_OFF & GCP_OFF & GWRP_OFF & COE_OFF & FWDTEN_OFF & ICS_PGx1 ) 
// 8MHz*PLL4=32MHz (Full Speed)
_CONFIG2( FCKSM_CSDCMD & OSCIOFNC_ON & POSCMOD_NONE & FNOSC_FRCPLL & I2C1SEL_PRI & IOL1WAY_OFF )

/// O[oϐ@///
char SaveBuf[100];			// ۑpobt@
char Buffer[150];				// GPSMpobt@
char MsgBuf1[17];				// \pobt@
char MsgBuf2[17];
unsigned int Flag, SaveFlag, Ptr, AxisFlag, MsrFlag, PwrCont;
/// vg^CsO
unsigned char FileOpen(void);
char GetData(void); 
/// t@CVXepϐ
int FileNo;
FSFILE *pointer;
DWORD writeSize;				// Write Size	
const char Header[] = "LogStart\r\n";
const char Terminator[] = "LogEnd\r\n"; 
/// t@CeLXg
const char FileName[9][12] =
 	{{"LOGGER0.TXT"},{"LOGGER1.TXT"},{"LOGGER2.TXT"},
	 {"LOGGER3.TXT"},{"LOGGER4.TXT"},{"LOGGER5.TXT"},
	 {"LOGGER6.TXT"},{"LOGGER7.TXT"},{"LOGGER8.TXT"}};

/***************************************
*  ԕω荞ݏ
**************************************/
void __attribute__((interrupt, no_auto_psv)) _CNInterrupt(void)
{
	IFS1bits.CNIF = 0;						// 荞݃tONA
	/***** t@CI[vN[Y@*****/
	if(PORTBbits.RB2 == 0)						// SW1 is On?		
	{
		if(SaveFlag == 0)
		{
			if(FileOpen() == 0){				// ɃI[v?
				lcd_cmd(0x80);
				lcd_str("File Open       ");	// Normally opened
				// File Number update for next open
				FileNo++;					// File Number Up
				if(FileNo > 7)				// File Number Check
				{
					FileNo = 0;				// back to 0
					lcd_cmd(0x80);
					lcd_str("File Number Over");
				}
				LATAbits.LATA4 = 0;			// LED1 On
				// File Header Write
				writeSize =  FSfwrite((const void*)Header, 10, 1, pointer);
				SaveFlag  = 1;
			}		
			else {
				lcd_cmd(0x80);
				lcd_str("File Open Error ");	// File open error
				FileNo = 0;
				SaveFlag = 0;					
			}
		}
		else
		{	//// t@Cۑ~
			// File termination Write
			writeSize =  FSfwrite((const void*)Terminator, 8, 1, pointer);
			FSfclose(pointer);
			SaveFlag = 0;
			lcd_cmd(0x80);
			lcd_str("Save Completed!!");		// 폑݊ //
			LATAbits.LATA4 = 1;				// LED1 Off
		}
		while(PORTBbits.RB2 == 0);	
		delay_ms(30);						
	}
	/**** SW2 On switch Power Control ****/
	if(PORTBbits.RB3 == 0)
	{
		PwrCont ^= 1;
		while(PORTBbits.RB3 == 0);	
		delay_ms(50);	
	}
}	

/********** C֐ ************/
int main(void)
{
	unsigned int  j;
	CLKDIV = 0;						// NbN1:1
	/// |[go͐ݒ
	AD1PCFG = 0xFFFF;
	TRISA = 0;						// all output
	TRISB = 0x038E;					// RB1,2,3,7,8,9 are input
	/// SDJ[hpvAbv
	CNPU2 = 0x00F0;					// CN21,22,23,24
	/// UART1st
	RPINR18bits.U1RXR = 1;				// UART1 RX to RP1
	RPOR0bits.RP0R = 3;				// UART1 TX to RP0
	/// UART1ݒ@9600bps 8rbg peBȂAt[Ȃ
	U1BRG = 103;						// 9600bps@16MHz
	U1MODE = 0b1000100000000000;		// UART1ݒ
	U1STA =  0b0100010000000000;		// UART1ݒ
	/// LED Off
	LATAbits.LATA0 = 1;				// LED0 Off	
	LATAbits.LATA4 = 1;				// LED1 Off
	/// Assign SDI pin to RP7
	RPINR20bits.SDI1R = 7;
	/// Assign SDO and SCK to RP5 and 4
	RPOR2bits.RP4R = 8;				// SCK1
	RPOR2bits.RP5R = 7;				// SDO1
	/// XCb`ԕω荞ݐݒ
	CNEN1bits.CN6IE = 1;
	CNEN1bits.CN7IE = 1;
	IEC1bits.CNIE = 1;				// ԕω荞݋
	/// obt@Aϐ
	for(j=0; j<100; j++)
		SaveBuf[j] = 0;
	Ptr = 0;
	SaveFlag = 0;
	FileNo = 0;
	AxisFlag = 0;
	MsrFlag = 0;
	PwrCont = 0;
	/// JnbZ[W\
	lcd_init();						// LCD Initilize
	lcd_clear();						// Erase
	lcd_str("Start!");				// Display Start Message
	/// GPSW[d
	LATAbits.LATA1 = 0;				// Power Off
	delay_ms(500);					// 500msec wait
	LATAbits.LATA1 = 1;				// Power On

	/*************** C[v ***********************/	
	while(1)
	{
		/******** GPS **********/
		Buffer[Ptr++] = GetData();
		if(Buffer[Ptr-1] == 0x0A)						// sR[hM
		{
			if(memcmp(Buffer, "$GPGGA", 6) == 0)		// GPGAAM
			{
				/*** \obt@Zbg ****/
				Flag = 1;							// \ptOI
				LATAbits.LATA0 = 0;					// Green LED On
				memcpy(MsgBuf1, Buffer+28, 1);			// N/S
				memcpy(MsgBuf1+1, Buffer+18, 9);		// ܓx
				MsgBuf1[10] = ' ';
				MsgBuf1[11] = 'H';
				memcpy(MsgBuf1+12, Buffer+54, 4);		// Aeix
				MsgBuf1[16] = 0;
				memcpy(MsgBuf2, Buffer+41, 1);			// E/W
				memcpy(MsgBuf2+1, Buffer+30, 9);		// ox
				MsgBuf2[10] = ' ';
				memcpy(MsgBuf2+12, Buffer+46, 1);		// q
				MsgBuf2[13] = ' ';
				memcpy(MsgBuf2+14, Buffer+11, 2);		// @b
				MsgBuf2[16] = 0;
				/*** ۑobt@Zbg ****/
				memcpy(SaveBuf, Buffer+7, 6);			// b
				memcpy(SaveBuf+6, Buffer+27, 2);		// ,N/S
				memcpy(SaveBuf+8, Buffer+17, 10);		// ,ܓx
				memcpy(SaveBuf+18, Buffer+40, 2);		// ,E/W
				memcpy(SaveBuf+20, Buffer+29, 12);		// ,ox,
				SaveBuf[32] = 'H';
				memcpy(SaveBuf+33, Buffer+52, 19);		// ,x,M,WICh,M
				memcpy(SaveBuf+52, Buffer+44, 4);		// ,q,
			}
			/*******@̃f[^M ************/
			if(Flag)									// \IH
			{
				if(memcmp(Buffer, "$GPVTG", 6) == 0)	// GPVTGM
				{
//					MsgBuf2[10] = 'V';
//					memcpy(MsgBuf2+11, Buffer+31, 4);	// x
					// Flle Save
					SaveBuf[56] = 'V';
					memcpy(SaveBuf+57, Buffer+28, 5);	// ,x
				}
				if(memcmp(Buffer, "$GPGSA", 6) == 0)	// GPGSAM
				{
					memcpy(MsgBuf2+11, Buffer+9, 1);	// ʏ
					// Flie Save
					memcpy(SaveBuf+62, Buffer+8, 2);	// ,ʏ
					SaveBuf[64] = 0x0D;				// CRLF
					SaveBuf[65] = 0x0A;
					if((MsgBuf2[11] == '2') || (MsgBuf2[11] == '3'))
						MsrFlag = 1;
				}
				/*** Ō̃bZ[WMmF ****/
				if(memcmp(Buffer, "$GPZDA", 6) == 0)	// GPZDAM(Ō̃f[^)
				{
					if(AxisFlag == 0)
					{
						printf("$PSRF106,21*0F\r\n");	// WnύXMo
						AxisFlag = 1;
					}
					// t\
					Flag = 0;						// \ptOIt
					lcd_cmd(0x80);
					lcd_str(MsgBuf1);					// 1sڕ\	
					lcd_cmd(0xC0);
					lcd_str(MsgBuf2);					// 2sڕ\
					LATAbits.LATA0 = 1;				// Green LED Off
					/*** Save with Power Control ***/
					if(PwrCont)
					{
						if(MsrFlag)
						{
							LATAbits.LATA4 = 0;			// LED1 On
							/// t@Cۑs
							SRbits.IPL = 7;
							if(SaveFlag)
								writeSize = FSfwrite((const void*)SaveBuf, 66, 1, pointer);
							SRbits.IPL = 0;
							/// GPSW[d
							LATAbits.LATA1 = 0;			// Power Off
							delay_ms(9000);				// 9sec wait
							LATAbits.LATA1 = 1;			// Power On
							MsrFlag = 0;
							delay_ms(1000);				// 1sec wait
							/*** No Power Control save every 10sec ***/
						}
					}
					else
					{
						if((SaveFlag) && (SaveBuf[5] == '0'))
						{	
							writeSize = FSfwrite((const void*)SaveBuf, 66, 1, pointer);
							LATAbits.LATA4 ^= 1;		// toggle LED1
						}
					}
				}
			}
			Ptr = 0;									// obt@CfbNXNA
		}		
	}
}

/***************************************
*  GPSMTu[`
*
***************************************/
char GetData(void)
{
	/// MG[`FbN
	if(U1STAbits.OERR || U1STAbits.FERR) {
		U1STA &= 0xFFF0;				// G[tONA
		U1MODEbits.UARTEN = 0;			// UART1~
		U1MODEbits.UARTEN = 1;			// UART1L
	}
	while(!U1STAbits.URXDA);			// ͑҂
	return(U1RXREG);					// f[^o
}

/*********************************
* t@CI[v֐
**********************************/
unsigned char FileOpen(void)
{
	SRbits.IPL = 7;
	/// t@C̎҂ƃfBNgǂݍ
	while(!FSInit());
	/// t@Ct@CŃI[v܂͐VK
	pointer = FSfopen(FileName[FileNo], "w");
	Nop();
	SRbits.IPL = 0;
	if(pointer == NULL)
		return(0xFF);	
	else
		return(0);
}
